' Web Test Ver 2
Option EXPLICIT
Option DEFAULT NONE
Option autorun on

dim float AvgVal = 0 'Pointless variables
dim integer TotTicks = 0
Dim Float TotVal = 0

? "Watchdog Value", mm.watchdog 'Print the watchdog value
if mm.watchdog > 0 then 'Has a watchdog timeout occurred?
  end 'Yes, stop the program
end if

SetPin 24, DOUT 'Setup the pin
pin(24) = 0 'Start from an off state

Do While MM.Info(IP ADDRESS) = "0.0.0.0"
Loop
? "Connected to WiFi.  Local IP address is " + MM.Info(ip address)

Do
  print "Connecting to NTP Server"
  On error skip
  WEB ntp 10 + 1
  If MM.Errno <> 0 And Timer < 2000 Then print "Waiting for NTP Server" 'Display msg
Loop Until MM.Errno = 0 'Keep going until there's no errors

? date$, time$
?

WEB TCP INTERRUPT WebInterrupt 'Catch the web traffic and deal with it
settick 1000, ShowTicks, 1 'Do something every 1 second

do 'Main code loop here
  timer = 0 'Reset the timer for cycle times
  Watchdog 20000 'WatchDog time-out value
loop 'Keep looping

sub WebInterrupt 'Web data has arrived
  local integer ConnNum 'Var for connection number
  local integer ConnData(512) 'Var for web data
  local String Host1, Host2 'Vars for hosts
  Host1 = MM.Info(ip address) 'The local IP Address
  Host2 = "210.50." 'The primary numbers for my ISP address
  for ConnNum = 1 to mm.info(max connections) 'Loop through all the connections
    longstring clear ConnData() 'Clear any previous data
    web tcp read ConnNum, ConnData() 'Get the web traffic
    if llen(ConnData()) > 0 then 'If the data has anything in it, do this
      ? "Web Interrupt -", Time$, date$ 'Display the page break, so we know web traffic has occured
      ? "Start time stamp:", timer 'Display the timer val for time stamp
      if linstr(ConnData(), "Host:") > 0 then 'Is the traffic from a legitimate host?
        ? "Host string found." 'Yes, we've found a 'host:' string, all good so far...
        if (linstr(ConnData(), Host1) > 0) or (linstr(ConnData(),Host2) > 0) then 'Address of local WebMite, or ISP?
          ? "Valid address found." 'We have a match!
          ?
          LongString print ConnData() 'Display the data that came in
          if linstr(ConnData(), "GET /test.html HTTP") then 'Is the pointless web page requested?
            ? "Sending test.html"
            WEB TRANSMIT PAGE ConnNum, "/test.html" 'Send the pointless page
          else if linstr(ConnData(), "GET /lizard.jpg") then 'Picture requested?
            ? "Sending lizard.jpg"
            web transmit file ConnNum, "lizard.jpg", "image/jpeg" 'Yeah, send it too...
          else
            ? "Sending 404 Code"
            web transmit code ConnNum, 404 'So far, so bad... move along, there's nothing to see here
          end if
        else
          ? "Error in Address." 'The address is a dud, deal with it from here
          ?
          LongString print ConnData() 'Display the data that came in
          ? "Closing connection"
          web tcp close ConnNum 'Close the connection to avoid a possible WatchDog error
        end if
      Else 'No WebMite address?
        ? "*** Error in Format ***" 'Display that we're not interested
        LongString print ConnData() 'Display the data that came in
        ? "Closing connection"
        web tcp close ConnNum 'Close the connection to avoid a possible WatchDog error
      end if
      
    end if
  next ConnNum 'Do the next connection
  ? "End time stamp:", timer 'Display the timer val for time stamp
  ? "-----------------------" 'Page break
  ?
end Sub

sub ShowTicks 'Pointless number crunching here
  local integer RndVal
  local integer i
  RndVal = 99 * math(rand)
  for i = 0 to RndVal
    pause 1
  next i
  TotTicks = TotTicks + 1
  TotVal = TotVal + timer
  AvgVal = TotVal / TotTicks
  pin(24) = not(pin(24)) 'Audible click of a relay
  'print "TotVal: " + str$(int(TotVal)), "TotTicks: " + str$(TotTicks), "Avg: " + str$(int(AvgVal)), "Rnd: " + str$(RndVal), "Tmr: " + str$(timer)
End Sub